//===============================================================================
// Copyright  Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Linq;

namespace BtsToolPack
{
    public partial class Form1 : Form,IManageLogging
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {

        }

        private void button2_Click(object sender, EventArgs e)
        {
 
        }

        private void button3_Click(object sender, EventArgs e)
        {

        

        }

        private void button4_Click(object sender, EventArgs e)
        {

        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            CatalogManager mgr = new CatalogManager();

             if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
             }

             String ItemType = comboBox1.SelectedItem.ToString();
             mgr.ShowPortStatus(ItemType);

             checkedListBox1.Items.Clear();

            foreach(object obj in mgr.al)
            {

                bool isChecked = obj.ToString().StartsWith("ON");
                string strObjTrimmed = obj.ToString();

                strObjTrimmed = StripExtraInfo(strObjTrimmed);

                checkedListBox1.Items.Add( strObjTrimmed ,isChecked);
                
            }

            listBox1.Items.Add("Query Completed " + DateTime.Now.ToString());


        }

        private static string StripExtraInfo(string strObjTrimmed)
        {
            strObjTrimmed = strObjTrimmed.Replace("ON:SEND:", "");
            strObjTrimmed = strObjTrimmed.Replace("OFF:SEND:", "");
            strObjTrimmed = strObjTrimmed.Replace("ON:RECEIVE:", "");
            strObjTrimmed = strObjTrimmed.Replace("OFF:RECEIVE:", "");
            strObjTrimmed = strObjTrimmed.Replace("ON:ORCHESTRATION:", "");
            strObjTrimmed = strObjTrimmed.Replace("OFF:ORCHESTRATION:", "");
            return strObjTrimmed;
        }

        private void button2_Click_1(object sender, EventArgs e)
        {

        }

        private void button1_Click_1(object sender, EventArgs e)
        {
        }

        private void tabPage2_Click(object sender, EventArgs e)
        {

        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            CatalogManager mgr = new CatalogManager();
            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }
            mgr.EnumAllReceivePortsForPolling(textBox2.Text);
        }


        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 1;

        }

        private void button5_Click(object sender, EventArgs e)
        {



            CatalogManager mgr = new CatalogManager();

            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }

            String ItemType = comboBox1.SelectedItem.ToString();
            mgr.ShowPortStatus(ItemType);

            checkedListBox1.Items.Clear();
            listBox1.Items.Clear();

            foreach (object obj in mgr.al)
            {

                bool isChecked = obj.ToString().StartsWith("ON");
                string strObjTrimmed = obj.ToString();

                strObjTrimmed = StripExtraInfo(strObjTrimmed);

                checkedListBox1.Items.Add(strObjTrimmed, isChecked);

            }

            if( saveFileDialog1.ShowDialog()==DialogResult.OK)
            {
                mgr.SaveToFile(saveFileDialog1.FileName);
            }

            listBox1.Items.Add("Export Completed " + DateTime.Now.ToString());


        }

        private void button6_Click(object sender, EventArgs e)
        {

            CatalogManager mgr = new CatalogManager();

            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }

            checkedListBox1.Items.Clear();
            listBox1.Items.Clear();


            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                mgr.ReadFromFile(openFileDialog1.FileName);

                foreach (object obj in mgr.al)
                {

                    bool isChecked = obj.ToString().StartsWith("ON");
                    string strObjTrimmed = obj.ToString();

                    strObjTrimmed = StripExtraInfo(strObjTrimmed);

                    checkedListBox1.Items.Add(strObjTrimmed, isChecked);

                }

                mgr.LoadToBiztalk();

                foreach (object obj in mgr.processErrors)
                {
                    listBox1.Items.Add(obj.ToString());

                }
               listBox1.Items.Add("Import Completed " + DateTime.Now.ToString() );
         
            }

           }

        private void button7_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
        }

        private void button8_Click(object sender, EventArgs e)
        {



        }

        private void button9_Click(object sender, EventArgs e)
        {
            AnalysisTool mgr = new AnalysisTool();
            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }


            treeView1.Nodes.Clear();
            treeView1.LabelEdit = true;
            treeView1.PathSeparator = "|";

            BtsNode rootNode = new BtsNode("Root");
            treeView1.Nodes.Add(rootNode);

            mgr.GetAllReceivePortAdresses(rootNode);

            
            treeView1.Sort();
            treeView1.ExpandAll();
            
        }

        private void button8_Click_1(object sender, EventArgs e)
        {
            
            treeView1.ExpandAll();

            
        }

        private void button10_Click(object sender, EventArgs e)
        {

            if (treeView1.Nodes.Count == 0) return;

            AnalysisTool mgr = new AnalysisTool();

            List<BtsNode> NodeList = new List<BtsNode>();
            mgr.GetAllNodes(NodeList, (BtsNode)treeView1.Nodes[0]);

            foreach (BtsNode tn in NodeList)
            {
                System.Diagnostics.Debug.WriteLine(tn.Text);
            }




            IEnumerable<BtsNode> sonuclar = from val in NodeList
                                           where val.Text.ToLower().Contains(searchString.Text.ToLower())
                                           select val;
            
          
            treeView1.CollapseAll();

                        
            //mark searc hresults with red and expand them
            foreach (BtsNode tn in sonuclar)
            {
                System.Diagnostics.Debug.WriteLine(tn.FullPath);

                treeView1.SelectedNode = tn;
                treeView1.SelectedNode.Expand();
                treeView1.SelectedNode.BackColor = Color.Yellow;
            }




 
        }

        private void button11_Click(object sender, EventArgs e)
        {
            treeView1.CollapseAll();

        }

        private void button13_Click(object sender, EventArgs e)
        {

            CatalogManager mgr = new CatalogManager();

            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }

            //default password file
            openFileDialog1.FileName = @"C:\PasswordConfig.xml";
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {

                mgr.SetPasswords(openFileDialog1.FileName, this);



            }

        }



        #region IManageLogging Members

        public void Write(string message)
        {
            listBox2.Items.Add(message);
        }

        #endregion

        private void button1_Click_2(object sender, EventArgs e)
        {
            CatalogManager mgr = new CatalogManager();

            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }

            mgr.EnumAllReceivePortsForSettingParam("-1");

        }

        private void button2_Click_2(object sender, EventArgs e)
        {
            CatalogManager mgr = new CatalogManager();

            if (textBox1.Text != "")
            {
                mgr.ConnectionString = textBox1.Text;
            }

            mgr.EnumAllReceivePortsForSettingParam("0");

        }
    }
}